pragma Ada_95;
pragma Source_File_Name (ahvenmain, Spec_File_Name => "b~ahven.ads");
pragma Source_File_Name (ahvenmain, Body_File_Name => "b~ahven.adb");
pragma Suppress (Overflow_Check);

with System.Restrictions;
with Ada.Exceptions;

package body ahvenmain is
   pragma Warnings (Off);

   E103 : Short_Integer; pragma Import (Ada, E103, "system__os_lib_E");
   E042 : Short_Integer; pragma Import (Ada, E042, "system__soft_links_E");
   E048 : Short_Integer; pragma Import (Ada, E048, "system__exception_table_E");
   E090 : Short_Integer; pragma Import (Ada, E090, "ada__io_exceptions_E");
   E114 : Short_Integer; pragma Import (Ada, E114, "ada__strings_E");
   E118 : Short_Integer; pragma Import (Ada, E118, "ada__strings__maps_E");
   E074 : Short_Integer; pragma Import (Ada, E074, "ada__tags_E");
   E089 : Short_Integer; pragma Import (Ada, E089, "ada__streams_E");
   E101 : Short_Integer; pragma Import (Ada, E101, "interfaces__c_E");
   E050 : Short_Integer; pragma Import (Ada, E050, "system__exceptions_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "system__file_control_block_E");
   E218 : Short_Integer; pragma Import (Ada, E218, "ada__streams__stream_io_E");
   E095 : Short_Integer; pragma Import (Ada, E095, "system__file_io_E");
   E099 : Short_Integer; pragma Import (Ada, E099, "system__finalization_root_E");
   E097 : Short_Integer; pragma Import (Ada, E097, "ada__finalization_E");
   E140 : Short_Integer; pragma Import (Ada, E140, "system__storage_pools_E");
   E132 : Short_Integer; pragma Import (Ada, E132, "system__finalization_masters_E");
   E180 : Short_Integer; pragma Import (Ada, E180, "system__storage_pools__subpools_E");
   E168 : Short_Integer; pragma Import (Ada, E168, "system__task_info_E");
   E230 : Short_Integer; pragma Import (Ada, E230, "ada__calendar_E");
   E142 : Short_Integer; pragma Import (Ada, E142, "system__pool_global_E");
   E038 : Short_Integer; pragma Import (Ada, E038, "system__secondary_stack_E");
   E216 : Short_Integer; pragma Import (Ada, E216, "system__strings__stream_ops_E");
   E198 : Short_Integer; pragma Import (Ada, E198, "system__tasking__initialization_E");
   E146 : Short_Integer; pragma Import (Ada, E146, "ada__real_time_E");
   E087 : Short_Integer; pragma Import (Ada, E087, "ada__text_io_E");
   E184 : Short_Integer; pragma Import (Ada, E184, "system__tasking__protected_objects_E");
   E202 : Short_Integer; pragma Import (Ada, E202, "system__tasking__protected_objects__entries_E");
   E206 : Short_Integer; pragma Import (Ada, E206, "system__tasking__queuing_E");
   E212 : Short_Integer; pragma Import (Ada, E212, "system__tasking__stages_E");
   E016 : Short_Integer; pragma Import (Ada, E016, "ahven_E");
   E014 : Short_Integer; pragma Import (Ada, E014, "ahven__listeners_E");
   E012 : Short_Integer; pragma Import (Ada, E012, "ahven__slist_E");
   E018 : Short_Integer; pragma Import (Ada, E018, "ahven__framework_E");
   E002 : Short_Integer; pragma Import (Ada, E002, "ahven__parameters_E");
   E022 : Short_Integer; pragma Import (Ada, E022, "ahven__results_E");
   E026 : Short_Integer; pragma Import (Ada, E026, "ahven__runner_E");
   E006 : Short_Integer; pragma Import (Ada, E006, "ahven__temporary_output_E");
   E028 : Short_Integer; pragma Import (Ada, E028, "ahven__listeners__basic_E");
   E030 : Short_Integer; pragma Import (Ada, E030, "ahven__tap_runner_E");
   E008 : Short_Integer; pragma Import (Ada, E008, "ahven__text_runner_E");
   E010 : Short_Integer; pragma Import (Ada, E010, "ahven__xml_runner_E");
   E004 : Short_Integer; pragma Import (Ada, E004, "ahven_compat_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      E030 := E030 - 1;
      declare
         procedure F1;
         pragma Import (Ada, F1, "ahven__tap_runner__finalize_spec");
      begin
         if E030 = 0 then
            F1;
         end if;
      end;
      E028 := E028 - 1;
      declare
         procedure F2;
         pragma Import (Ada, F2, "ahven__listeners__basic__finalize_spec");
      begin
         if E028 = 0 then
            F2;
         end if;
      end;
      E022 := E022 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "ahven__results__finalize_spec");
      begin
         if E022 = 0 then
            F3;
         end if;
      end;
      E018 := E018 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "ahven__framework__finalize_spec");
      begin
         if E018 = 0 then
            F4;
         end if;
      end;
      E014 := E014 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ahven__listeners__finalize_spec");
      begin
         if E014 = 0 then
            F5;
         end if;
      end;
      E202 := E202 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         if E202 = 0 then
            F6;
         end if;
      end;
      E087 := E087 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "ada__text_io__finalize_spec");
      begin
         if E087 = 0 then
            F7;
         end if;
      end;
      declare
         procedure F8;
         pragma Import (Ada, F8, "system__file_io__finalize_body");
      begin
         E095 := E095 - 1;
         if E095 = 0 then
            F8;
         end if;
      end;
      E132 := E132 - 1;
      E180 := E180 - 1;
      E142 := E142 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "system__pool_global__finalize_spec");
      begin
         if E142 = 0 then
            F9;
         end if;
      end;
      declare
         procedure F10;
         pragma Import (Ada, F10, "system__storage_pools__subpools__finalize_spec");
      begin
         if E180 = 0 then
            F10;
         end if;
      end;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__finalization_masters__finalize_spec");
      begin
         if E132 = 0 then
            F11;
         end if;
      end;
      E218 := E218 - 1;
      declare
         procedure F12;
         pragma Import (Ada, F12, "ada__streams__stream_io__finalize_spec");
      begin
         if E218 = 0 then
            F12;
         end if;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure ahvenfinal is

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      finalize_library;
   end ahvenfinal;

   type No_Param_Proc is access procedure;

   procedure ahveninit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           True, False, False, False, False, False, False, False, 
           False, False, False, False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (False, True, False, True, True, False, False, True, 
           False, False, True, True, True, True, False, False, 
           True, False, False, True, True, False, True, True, 
           False, True, True, True, True, True, False, True, 
           False, True, False, True, True, False, True, False, 
           True, True, False, False, False, True, True, False, 
           False, True, False, True, False, False, True, False, 
           True, False, True, True, True, False, False, True, 
           False, False, True, False, True, True, False, True, 
           True, True, False, True, False, False, False, False, 
           False, True, True, False, True, False),
         Count => (0, 0, 0, 0, 0, 2, 1, 0, 1, 0),
         Unknown => (False, False, False, False, False, False, True, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      if E042 = 0 then
         System.Soft_Links'Elab_Spec;
      end if;
      if E048 = 0 then
         System.Exception_Table'Elab_Body;
      end if;
      E048 := E048 + 1;
      if E090 = 0 then
         Ada.Io_Exceptions'Elab_Spec;
      end if;
      E090 := E090 + 1;
      if E114 = 0 then
         Ada.Strings'Elab_Spec;
      end if;
      E114 := E114 + 1;
      if E118 = 0 then
         Ada.Strings.Maps'Elab_Spec;
      end if;
      if E074 = 0 then
         Ada.Tags'Elab_Spec;
      end if;
      if E089 = 0 then
         Ada.Streams'Elab_Spec;
      end if;
      E089 := E089 + 1;
      if E101 = 0 then
         Interfaces.C'Elab_Spec;
      end if;
      if E050 = 0 then
         System.Exceptions'Elab_Spec;
      end if;
      E050 := E050 + 1;
      if E106 = 0 then
         System.File_Control_Block'Elab_Spec;
      end if;
      E106 := E106 + 1;
      if E218 = 0 then
         Ada.Streams.Stream_Io'Elab_Spec;
      end if;
      E218 := E218 + 1;
      if E099 = 0 then
         System.Finalization_Root'Elab_Spec;
      end if;
      E099 := E099 + 1;
      if E097 = 0 then
         Ada.Finalization'Elab_Spec;
      end if;
      E097 := E097 + 1;
      if E140 = 0 then
         System.Storage_Pools'Elab_Spec;
      end if;
      E140 := E140 + 1;
      if E132 = 0 then
         System.Finalization_Masters'Elab_Spec;
      end if;
      if E180 = 0 then
         System.Storage_Pools.Subpools'Elab_Spec;
      end if;
      if E168 = 0 then
         System.Task_Info'Elab_Spec;
      end if;
      E168 := E168 + 1;
      if E230 = 0 then
         Ada.Calendar'Elab_Spec;
      end if;
      if E230 = 0 then
         Ada.Calendar'Elab_Body;
      end if;
      E230 := E230 + 1;
      if E142 = 0 then
         System.Pool_Global'Elab_Spec;
      end if;
      E142 := E142 + 1;
      E180 := E180 + 1;
      if E132 = 0 then
         System.Finalization_Masters'Elab_Body;
      end if;
      E132 := E132 + 1;
      if E095 = 0 then
         System.File_Io'Elab_Body;
      end if;
      E095 := E095 + 1;
      E101 := E101 + 1;
      if E074 = 0 then
         Ada.Tags'Elab_Body;
      end if;
      E074 := E074 + 1;
      E118 := E118 + 1;
      if E042 = 0 then
         System.Soft_Links'Elab_Body;
      end if;
      E042 := E042 + 1;
      if E103 = 0 then
         System.Os_Lib'Elab_Body;
      end if;
      E103 := E103 + 1;
      if E038 = 0 then
         System.Secondary_Stack'Elab_Body;
      end if;
      E038 := E038 + 1;
      if E216 = 0 then
         System.Strings.Stream_Ops'Elab_Body;
      end if;
      E216 := E216 + 1;
      if E198 = 0 then
         System.Tasking.Initialization'Elab_Body;
      end if;
      E198 := E198 + 1;
      if E146 = 0 then
         Ada.Real_Time'Elab_Spec;
      end if;
      if E146 = 0 then
         Ada.Real_Time'Elab_Body;
      end if;
      E146 := E146 + 1;
      if E087 = 0 then
         Ada.Text_Io'Elab_Spec;
      end if;
      if E087 = 0 then
         Ada.Text_Io'Elab_Body;
      end if;
      E087 := E087 + 1;
      if E184 = 0 then
         System.Tasking.Protected_Objects'Elab_Body;
      end if;
      E184 := E184 + 1;
      if E202 = 0 then
         System.Tasking.Protected_Objects.Entries'Elab_Spec;
      end if;
      E202 := E202 + 1;
      if E206 = 0 then
         System.Tasking.Queuing'Elab_Body;
      end if;
      E206 := E206 + 1;
      if E212 = 0 then
         System.Tasking.Stages'Elab_Body;
      end if;
      E212 := E212 + 1;
      if E016 = 0 then
         Ahven'Elab_Spec;
      end if;
      E016 := E016 + 1;
      if E014 = 0 then
         Ahven.Listeners'Elab_Spec;
      end if;
      E014 := E014 + 1;
      E012 := E012 + 1;
      if E018 = 0 then
         Ahven.Framework'Elab_Spec;
      end if;
      E018 := E018 + 1;
      if E002 = 0 then
         Ahven.Parameters'Elab_Spec;
      end if;
      E002 := E002 + 1;
      if E022 = 0 then
         Ahven.Results'Elab_Spec;
      end if;
      E022 := E022 + 1;
      if E006 = 0 then
         Ahven.Temporary_Output'Elab_Spec;
      end if;
      E006 := E006 + 1;
      if E028 = 0 then
         Ahven.Listeners.Basic'Elab_Spec;
      end if;
      E028 := E028 + 1;
      E026 := E026 + 1;
      if E030 = 0 then
         Ahven.Tap_Runner'Elab_Spec;
      end if;
      E030 := E030 + 1;
      E008 := E008 + 1;
      E004 := E004 + 1;
      E010 := E010 + 1;
   end ahveninit;

--  BEGIN Object file/option list
   --   ./ahven.o
   --   ./ahven-astrings.o
   --   ./ahven-long_astrings.o
   --   ./ahven-listeners.o
   --   ./ahven-slist.o
   --   ./ahven-framework.o
   --   ./ahven-parameters.o
   --   ./ahven-results.o
   --   ./ahven-temporary_output.o
   --   ./ahven-listeners-basic.o
   --   ./ahven-runner.o
   --   ./ahven-tap_runner.o
   --   ./ahven-text_runner.o
   --   ./ahven_compat.o
   --   ./ahven-xml_runner.o
   --   -L./
   --   -L/builddir/build/BUILD/ahven-2.4/contrib/comfignat/gnat/obj/aarch64/
   --   -L/usr/lib/gcc/aarch64-redhat-linux/5.0.0/adalib/
   --   -static
   --   -lgnarl
   --   -lgnat
   --   -lpthread
   --   -lrt
--  END Object file/option list   

end ahvenmain;
